﻿using System;

namespace People
{
    public class Person
    {
        private string _name;
        private char _gender;

        public Person(string name, char gender)
        {
            CheckName(name);
            CheckGender(gender);
            _name = name;
            _gender = gender;
        }

        public String Name
        {
            get { return _name; }
            set
            {
                CheckName(value);
                _name = value;
            }
        }

        public char Gender
        {
            get { return _gender; }
            set
            {
                CheckGender(value);
                _gender = value;
            }
        }

        /// <summary>
        /// Returns a string that represents the current object.
        /// </summary>
        /// <returns>
        /// A string that represents the current object.
        /// </returns>
        //public override string ToString()
        //{
        //    return string.Format("Person({0}, {1})", Name, Gender);
        //}




        private static void CheckGender(char gender)
        {
            if (gender == 'M' || gender == 'F')
            {
                /* empty */
            }
            else
            {
                throw new ArgumentException(string.Format("gender must be either M or F: {0}", gender));
            }
        }

        private static void CheckName(string name)
        {
            if (String.IsNullOrEmpty(name))
            {
                throw new ArgumentException("name is null or empty");
            }
        }

    }
}
